Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.cache.loader
Class DelegatingCacheLoader

    java.lang.Object
      org.jboss.cache.loader.DelegatingCacheLoader

All Implemented Interfaces:
  CacheLoader, org.jboss.system.Service

public class DelegatingCacheLoader
extends Object
implements CacheLoader

CacheLoader implementation which delegates to another TreeCache. This allows to stack caches on top of each other, allowing for hierarchical cache levels. For example, first level cache delegates to a second level cache, which delegates to a persistent cache. Sample code:

     TreeCache firstLevel=new TreeCache();
     TreeCache secondLevel=new TreeCache();
     DelegatingCacheLoader l=new DelegatingCacheLoader(secondLevel);
     l.setCache(firstLevel);
     firstLevel.setCacheLoader(l);
     secondLevel.start();
     firstLevel.start();

Version:
  $Id: DelegatingCacheLoader.java,v 1.2 2004/11/30 14:06:07 belaban Exp $
Author:
  Bela Ban

Constructor Summary
`DelegatingCacheLoader(TreeCache delegate)`

Method Summary
`void` | `commit(Object tx)` Commit the transaction.
`void` | `create()`
`void` | `destroy()`
`boolean` | `exists(Fqn name)` Checks whether the CacheLoader has a node with Fqn
`Map` | `get(Fqn name)` Returns all keys and values from the persistent store, given a fully qualified name
`Object` | `get(Fqn name, Object key)` Returns the value for a given key.
`Set` | `getChildrenNames(Fqn fqn)` Returns a list of children names, all names are relative.
`byte[]` | `loadEntireState()` Fetch the entire state for this cache from secondary storage (disk, DB) and return it as a byte buffer.
`void` | `prepare(Object tx, List modifications, boolean one_phase)` Prepare the modifications.
`void` | `put(Fqn name, Map attributes)` Inserts all elements of attributes into the attributes hashmap of the given node, overwriting existing attributes, but not clearing the existing hashmap before insertion (making it a union of existing and new attributes) If the node does not exist, all parent nodes from the root down are created automatically
`void` | `put(Fqn fqn, Map attributes, boolean erase)`
`Object` | `put(Fqn name, Object key, Object value)` Inserts key and value into the attributes hashmap of the given node.
`void` | `put(List modifications)` Inserts all modifications to the backend store.
`void` | `remove(Fqn name)` Removes the given node.
`Object` | `remove(Fqn name, Object key)` Removes the given key and value from the attributes of the given node.
`void` | `removeData(Fqn name)` Removes all attributes from a given node, but doesn't delete the node itself
`void` | `rollback(Object tx)` Roll the transaction back.
`void` | `setCache(TreeCache c)` This method allows the CacheLoader to set the TreeCache, therefore allowing the CacheLoader to invoke methods of the TreeCache.
`void` | `setConfig(Properties props)` Sets the configuration.
`void` | `start()`
`void` | `stop()`
`void` | `storeEntireState(byte[] state)` Store the given state in secondary storage.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DelegatingCacheLoader

    public DelegatingCacheLoader(TreeCache delegate)

Method Detail

### setConfig

    public void setConfig(Properties props)

  Description copied from interface: `CacheLoader`
  Sets the configuration. Will be called before `Service.create()` and `Service.start()`

  Specified by:
    `setConfig` in interface `CacheLoader`
  Parameters:
    `props` - A list of properties, defined in the XML file

### setCache

    public void setCache(TreeCache c)

  Description copied from interface: `CacheLoader`
  This method allows the CacheLoader to set the TreeCache, therefore allowing the CacheLoader to invoke methods of the TreeCache. It can also use the TreeCache to fetch configuration information. Alternatively, the CacheLoader could maintain its own configuration
  This method will be called directly after the CacheLoader instance has been created

  Specified by:
    `setCache` in interface `CacheLoader`
  Parameters:
    `c` - The cache on which this loader works

### getChildrenNames

    public Set getChildrenNames(Fqn fqn)
                         throws Exception

  Description copied from interface: `CacheLoader`
  Returns a list of children names, all names are relative. Returns null if the parent node is not found. The returned set must not be modified, e.g. use Collections.unmodifiableSet(s) to return the result

  Specified by:
    `getChildrenNames` in interface `CacheLoader`
  Parameters:
    `fqn` - The FQN of the parent
  Returns:
    Set. A list of children. Returns null if no children nodes are present, or the parent is not present
  Throws:
    `Exception`

### get

    public Object get(Fqn name,
                      Object key)
               throws Exception

  Description copied from interface: `CacheLoader`
  Returns the value for a given key. Returns null if the node doesn't exist, or the value is not bound

  Specified by:
    `get` in interface `CacheLoader`
  Parameters:
    `name` -
  Returns:
  Throws:
    `Exception`

### get

    public Map get(Fqn name)
            throws Exception

  Description copied from interface: `CacheLoader`
  Returns all keys and values from the persistent store, given a fully qualified name

  Specified by:
    `get` in interface `CacheLoader`
  Parameters:
    `name` -
  Returns:
    Map of keys and values for the given node. Returns null if the node was not found, or if the node has no attributes
  Throws:
    `Exception`

### exists

    public boolean exists(Fqn name)
                   throws Exception

  Description copied from interface: `CacheLoader`
  Checks whether the CacheLoader has a node with Fqn

  Specified by:
    `exists` in interface `CacheLoader`
  Parameters:
    `name` -
  Returns:
    True if node exists, false otherwise
  Throws:
    `Exception`

### put

    public Object put(Fqn name,
                      Object key,
                      Object value)
               throws Exception

  Description copied from interface: `CacheLoader`
  Inserts key and value into the attributes hashmap of the given node. If the node does not exist, all parent nodes from the root down are created automatically. Returns the old value

  Specified by:
    `put` in interface `CacheLoader`
  Throws:
    `Exception`

### put

    public void put(Fqn name,
                    Map attributes)
             throws Exception

  Description copied from interface: `CacheLoader`
  Inserts all elements of attributes into the attributes hashmap of the given node, overwriting existing attributes, but not clearing the existing hashmap before insertion (making it a union of existing and new attributes) If the node does not exist, all parent nodes from the root down are created automatically

  Specified by:
    `put` in interface `CacheLoader`
  Parameters:
    `name` - The fully qualified name of the node
    `attributes` - A Map of attributes. Can be null
  Throws:
    `Exception`

### put

    public void put(Fqn fqn,
                    Map attributes,
                    boolean erase)
             throws Exception

  Throws:
    `Exception`

### put

    public void put(List modifications)
             throws Exception

  Description copied from interface: `CacheLoader`
  Inserts all modifications to the backend store. Overwrite whatever is already in the datastore.

  Specified by:
    `put` in interface `CacheLoader`
  Parameters:
    `modifications` - A List of modifications
  Throws:
    `Exception`

### remove

    public Object remove(Fqn name,
                         Object key)
                  throws Exception

  Description copied from interface: `CacheLoader`
  Removes the given key and value from the attributes of the given node. No-op if node doesn't exist

  Specified by:
    `remove` in interface `CacheLoader`
  Throws:
    `Exception`

### remove

    public void remove(Fqn name)
                throws Exception

  Description copied from interface: `CacheLoader`
  Removes the given node. If the node is the root of a subtree, this will recursively remove all subnodes, depth-first

  Specified by:
    `remove` in interface `CacheLoader`
  Throws:
    `Exception`

### removeData

    public void removeData(Fqn name)
                    throws Exception

  Description copied from interface: `CacheLoader`
  Removes all attributes from a given node, but doesn't delete the node itself

  Specified by:
    `removeData` in interface `CacheLoader`
  Parameters:
    `name` -
  Throws:
    `Exception`

### prepare

    public void prepare(Object tx,
                        List modifications,
                        boolean one_phase)
                 throws Exception

  Description copied from interface: `CacheLoader`
  Prepare the modifications. For example, for a DB-based CacheLoader:
  1. Create a local (JDBC) transaction
  2. Associate the local transaction with `tx` (tx is the key)
  3. Execute the coresponding SQL statements against the DB (statements derived from modifications)
  For non-transactional CacheLoader (e.g. file-based), this could be a null operation

  Specified by:
    `prepare` in interface `CacheLoader`
  Parameters:
    `tx` - The transaction, just used as a hashmap key
    `modifications` - List, a list of all modifications within the given transaction
    `one_phase` - Persist immediately and (for example) commit the local JDBC transaction as well. When true, we won't get a `CacheLoader.commit(Object)` or `CacheLoader.rollback(Object)` method call later
  Throws:
    `Exception`

### commit

    public void commit(Object tx)
                throws Exception

  Description copied from interface: `CacheLoader`
  Commit the transaction. A DB-based CacheLoader would look up the local JDBC transaction asociated with `tx` and commit that transaction
  Non-transactional CacheLoaders could simply write the data that was previously saved transiently under the given `tx` key, to (for example) a file system (note this only holds if the previous prepare() did not define one_phase=true

  Specified by:
    `commit` in interface `CacheLoader`
  Parameters:
    `tx` -
  Throws:
    `Exception`

### rollback

    public void rollback(Object tx)

  Description copied from interface: `CacheLoader`
  Roll the transaction back. A DB-based CacheLoader would look up the local JDBC transaction asociated with `tx` and roll back that transaction

  Specified by:
    `rollback` in interface `CacheLoader`
  Parameters:
    `tx` -

### loadEntireState

    public byte[] loadEntireState()
                           throws Exception

  Description copied from interface: `CacheLoader`
  Fetch the entire state for this cache from secondary storage (disk, DB) and return it as a byte buffer. This is for initialization of a new cache from a remote cache. The new cache would then call storeEntireState().
  todo: define binary format for exchanging state

  Specified by:
    `loadEntireState` in interface `CacheLoader`
  Throws:
    `Exception`

### storeEntireState

    public void storeEntireState(byte[] state)
                          throws Exception

  Description copied from interface: `CacheLoader`
  Store the given state in secondary storage. Overwrite whatever is currently in seconday storage.

  Specified by:
    `storeEntireState` in interface `CacheLoader`
  Throws:
    `Exception`

### create

    public void create()
                throws Exception

  Specified by:
    `create` in interface `org.jboss.system.Service`
  Throws:
    `Exception`

### start

    public void start()
               throws Exception

  Specified by:
    `start` in interface `org.jboss.system.Service`
  Throws:
    `Exception`

### stop

    public void stop()

  Specified by:
    `stop` in interface `org.jboss.system.Service`

### destroy

    public void destroy()

  Specified by:
    `destroy` in interface `org.jboss.system.Service`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002 JBoss Group, LLC. All Rights Reserved.